; setaudio Copyright (c) 2014 Elmar de Koning edekoning@gmail.com


; make sure we received at least one parameter
if 0 < 1
{
	MsgBox usage: setaudio <target>`n`n where <target> is the name of the audio device to set as default
	Exit
}
; open the Sound control panel
Run, mmsys.cpl
WinWait, Sound,,5
WinActivate

; the description of the default playback device ends with this string
isdefault := "Default Device"
; the button text to the set a playback device as default
setdefault := "&Set Default"
; the playback device to set as default
target = %1%

; for each audio playback device
ControlGet, List, List,, SysListView321, Sound
Loop, Parse, List, `n
{
	; is target device
	If InStr(A_LoopField, target)
	{
		; is not default device
		if NOT InStr(A_LoopField, isdefault)
		{
			; set as default device
			ControlSend, SysListView321, {Down %A_Index%}, Sound
			ControlClick, %setdefault%, Sound, , , , NA
		}
		break
	}
}
; close the sound control panel
Send {Esc}